//common functions
function getAjax(url, callback){
    var xhr = new XMLHttpRequest();
    xhr.onreadystatechange = function(data) {
        if (xhr.readyState == 4) {
            if (xhr.status == 200) {
              var dataText = xhr.responseText;
              if(dataText!=null)
                callback(dataText);
            } else {
              //callback(null);
            }
        }
    }
    xhr.open('GET', url, true);
    xhr.send();
}


//获取分词
chrome.extension.onRequest.addListener(onRequest);
function onRequest(request, sender, callback) {
    if (request.url){
        getAjax(request.url, callback);
        //  var xhr = new XMLHttpRequest();
        //  xhr.onreadystatechange = function(data) {
        //   if (xhr.readyState == 4) {
        //     if (xhr.status == 200) {
        //       var dataText = xhr.responseText;
        //       if(dataText!=null)
        //         callback(dataText);
        //     } else {
        //       //callback(null);
        //     }
        //   }
        // }
        // xhr.open('GET', request.url, true);
        // xhr.send();
    }
};

//本地存储
var OptionsChanged = false;
var DefaultOptions = {
    "op_fetchword": {"checked": true},
    "op_selword": {"checked": false},
    "op_only_english": {"checked": false},
    "op_pie": {"checked": true}
};
if (localStorage["ColorOptions"] == undefined){
    localStorage["ColorOptions"] = JSON.stringify(DefaultOptions);
}
chrome.extension.onRequest.addListener(
  function(request, sender, sendResponse){
    if (request.act == "init"){
      if(request.type == 'listen'){
        if(OptionsChanged==true){
          sendResponse({
            status: "inited",
            type: request.type,
            OptionsChanged: OptionsChanged,
            ColorOptions: JSON.parse(localStorage["ColorOptions"])
          });
          OptionsChanged = false;
        } else {
          sendResponse({
            status: "inited",
            type: request.type,
            OptionsChanged: OptionsChanged,
          });
        }
      } else {
        sendResponse({
          status: "inited",
          ColorOptions: JSON.parse(localStorage["ColorOptions"])
        });
      }
    }
    if (request.act == "save"){
      localStorage["ColorOptions"] = JSON.stringify(request.data);
      OptionsChanged = true;
      sendResponse({
        status: "saved"
      });
    }
  }
);

//安装升级统计
var env = '';
var version = '1.0.2';
var btype = 'chrome';

var tjurl = 'http://'+env+'app2.dict.cn/plugins/common/tj.php?back=json&btype='+btype+'&ver='+version+'&tj=';
var tjtype = '';
if (localStorage["hcdict_ver"] == undefined){ //安装统计
    tjtype = 'install'
    tjurl = tjurl + tjtype;
    getAjax(tjurl, function(data){
        try{ data = JSON.parse(data); } catch(e){};
        if(data && data.status){
            localStorage["hcdict_ver"] = version;
        }
    });
} else {//升级统计
    tjtype = 'update';
    tjurl = tjurl + tjtype;
    if(localStorage["hcdict_ver"]<version){
      tjtype = 'upgrade';
      tjurl = tjurl + tjtype;
      getAjax(tjurl, function(data){
          try{ data = JSON.parse(data); } catch(e){};
          if(data && data.status){
              localStorage["hcdict_ver"] = version;
          }
      });
    }
}
