/**
 * options.html and index.html
 */

//初始化
var env = dictcnEnv ? dictcnEnv : '';
var root_url = 'http://'+env+'dict.cn';
var md5_salt = make_md5_salt('73968t727aac3ee8bai593473d960c8x');
var act = '';

//创建样式
var styleInsert = document.createElement("style"),
styleContent = document.createTextNode(".btnclose,.search-nav a{background-image: url("+chrome.extension.getURL("images/dict_chrome_img01.png")+");}");
styleInsert.type = "text/css";
if (styleInsert.styleSheet) styleInsert.styleSheet.cssText = styleContent.nodeValue;
else {
  styleInsert.appendChild(styleContent);
  document.getElementsByTagName("head")[0].appendChild(styleInsert)
}

//初始化选项
function updateOptions(){
    initColorOptions(function(options){
        //index.html
        if(id('op_idx_selword')) id('op_idx_selword').className=(options.op_selword.checked ? 'available':'unavailable');
        if(id('op_idx_fetchword')) id('op_idx_fetchword').className=(options.op_fetchword.checked ? 'available':'unavailable');

        //options.html
        if(id('op_fetchword')) id('op_fetchword').checked = options.op_fetchword.checked;
        if(id('op_selword')) id('op_selword').checked = options.op_selword.checked;
        if(id('op_only_english')) id('op_only_english').checked = options.op_only_english.checked;
        if(id('op_pie')) id('op_pie').checked = options.op_pie.checked;

        globalColorOptions = options;
    });
}
updateOptions();

//划词
if(id('op_idx_selword')){
    id('op_idx_selword').onclick = function(){
        if(this.className=='available'){
           this.className = 'unavailable';
           globalColorOptions.op_selword.checked = false;
        } else {
            this.className = 'available';
            globalColorOptions.op_selword.checked = true;
        }
        save_options(globalColorOptions,false); 
    }
}

//取词
if(id('op_idx_fetchword')){
    id('op_idx_fetchword').onclick = function(){
        if(this.className=='available'){
           this.className = 'unavailable';
           globalColorOptions.op_fetchword.checked = false;
           
        } else {
            this.className = 'available';
            globalColorOptions.op_fetchword.checked = true;
            
        }
        save_options(globalColorOptions,false);
    }
}

//搜索
if(id('qbtn')){
    id('qbtn').onclick = function(){
        var word = id('q').value, pie = '';
        if(!word) return;
        var saltmd5 = md5(rawurlencode(word+'0'+md5_salt));
        if(globalColorOptions.op_pie.checked) pie = '&pie=1';
        var tj = 'chaci';
        id('hcDictContent').src = root_url+'/apis/dict_plugin.php?skin=default'+pie+'&tj='+tj+'&btype='+dictcnBrowserType+'&ver='+dictcnVersion+'&inner=1&t='+saltmd5+'&pos=0&q='+encodeURIComponent(word);
    }
}

//打开网站查词
if(id('godetail')){
    id('godetail').onclick = function(){
        var word = id('q').value ? _trim(id('q').value) : '';
        if(word){
            id('godetail').href = root_url + '/' + encodeURIComponent(word) + '?oref=chajian-'+dictcnBrowserType+'-search';
        } else {
            id('godetail').href = root_url + '/' + '?oref=chajian-'+dictcnBrowserType+'-search';
        }
    }
}

//初始化iframe高度
var resMinHeight = 150;
    resMaxHeight = 412;
    cotentRunHeight = 412,
    contentRunScrolling = 'no';
function onFrameMessage (e){
    if(e.data && e.data.act=='keydown'){
        if(e.data.code==8){ //禁用cancel键引起的回退
            var $q = $('#q');
            if($q.length && !$q.is(':focus')){
                $q.val($q.val().substr(0, $q.val().length-1));
                $q.focus();
                //return false;
            }
        } else { //快速输入
            var $q = $('#q');
            if($q.length && !$q.is(':focus')) $q.focus();
        }
        return;
    }
    if(e.data && e.data.act=='focus'){ //iframe点击事件
        qblur();
        return;
    }
    if(e.data && e.data.act=='so'){ //英语链接
        id('q').value = e.data.word;
        id('qbtn').onclick();
        return;
    }
    var content = id('hcDictContent');
    if(e.data && e.data.height && e.data.height>resMinHeight){
        var frmHeight = parseInt(e.data.height);
        if(frmHeight>resMaxHeight){
            content.scrolling='yes';
            frmHeight = resMaxHeight;
        } else {
            content.scrolling='no';
        }
        content.height = frmHeight +'px';
    } else {
        content.scrolling='no';
        content.height = resMinHeight + 'px';
    }
    $('#render').html(Math.random());
    if(content.height) cotentRunHeight = content.height;
    if(content.scrolling) contentRunScrolling = content.scrolling;
}
window.addEventListener('message', onFrameMessage, false);

//enter键提交
window.document.onkeydown = function(e){
    e = window.event || e;
    if(e.keyCode==13){//如果取到的键值是回车
        id('qbtn').onclick();
    } else if(e.keyCode==8){ //禁用cancel键引起的回退
        var $q = $('#q');
        if($q.length && !$q.is(':focus')){
            $q.focus();
            //return false;
        }
    } else { //快速输入
        var $q = $('#q');
        if($q.length && !$q.is(':focus')) $q.focus();
    }
}

if(id('save')){
    id('save').onclick = function(){
        globalColorOptions.op_fetchword.checked = id('op_fetchword').checked;
        globalColorOptions.op_selword.checked = id('op_selword').checked;
        globalColorOptions.op_only_english.checked = id('op_only_english').checked;
        globalColorOptions.op_pie.checked = id('op_pie').checked;
        if(act=='inner'){
            save_options(globalColorOptions,false);
            showOptions(false);
        } else {
            save_options(globalColorOptions,true);
        }
        
    }
}

//保存数据
function save_options(ColorOptions,tips){
    chrome.extension.sendRequest(
        {
            act: "save",
            data: ColorOptions
        },
        function(response){
            if (response.status=='saved'){
                updateOptions();
                if(typeof tips=='undefined') tips = true;
                if(tips) showSucess('保存成功！');
            }
        }
    );
}

//通知page.js重新更新globalColorOptions
// window.addEventListener("storage",function(){
//     chrome.extension.sendMessage(
//         {
//             act: "restore",
//             data: globalColorOptions
//         }
//     );
// },false);

//显示保存成功
function showSucess(str){
    id('tips').style.display='block';
    id('tips').innerHTML = str;
    setTimeout(function(){
        id('tips').style.display='none';
    },2000);
}

function showOptions(yes){
    if(yes){
        id('hcDictContent').height = 150;
        id('hcDictContent').scrolling = 'no';
        id('optionContainner').style.display = 'block';
    } else {
        id('optionContainner').style.display = 'none';
        id('hcDictContent').height = cotentRunHeight,
        id('hcDictContent').scrolling = contentRunScrolling;
    }
}

function qblur(){
    var q = id('q');
        q.value = q.value+' ';
        q.value = q.value.replace(/ $/,'');
        q.blur();
}

$(function(){
    //加载每日一句
    if(dictcnEnv) $('#hcDictContent').attr('src', 'http://'+dictcnEnv+'app2.dict.cn/plugins/common/daily.php');
    //查词搜索框焦点事件
    $('#q').focus(function(){
        $(this).one('click',function(){$(this).select()});
    }).focus();
    try{
        window.frames['hcDictContent'].document.onclick=function (){
            qblur();
        }
    }catch(e){}
    //关闭按钮事件
    $('body').mouseenter(function(event) {
        $('#btnClose').show();
    }).mouseleave(function(event) {
        $('#btnClose').hide();
    });
    $('#btnClose').click(function(event) {
        window.close();
    });

    //导航事件
    $('.search-nav a').click(function(event) {
        if(dictcnEnv) $(this).attr('href', 'http://'+dictcnEnv+$(this).attr('href').replace(/^http:\/\//i,''));
    });
});

id('op-btn').onclick = function(){
    showOptions(true);
    id('a_back').innerHTML = '返回&gt;&gt;';
    act='inner';
}

id('a_back').onclick = function(){
    if(act=='inner') showOptions(false);
}

